use maud::{PreEscaped, html};

use crate::ui::color::UIColor;

#[allow(non_snake_case)]
pub fn MaterialIcon(identifier: &str) -> PreEscaped<String> {
    html! {
        span class="material-symbols-outlined select-none" { (identifier) };
    }
}

#[allow(non_snake_case)]
pub fn ColoredMaterialIcon<C: UIColor + 'static>(identifier: &str, color: C) -> PreEscaped<String> {
    html! {
        span class=(format!("material-symbols-outlined select-none text-{}", color.color_class())) { (identifier) };
    }
}
